/*
1. 代码需要符合**ES5**标准，ES6的语法会导致 iOS9 设备白屏
*/

jd.o_openToast = function (params) {
  jd.__invokeMethod__("o_openToast", params); //nativeAPIname为原生方法的名称
};

jd.postMessageToNative = function (params) {
  jd.__invokeMethod__("postMessageToNative", params); //nativeAPIname为原生方法的名称
};

jd.onCustomEvent = function (eventName, callback) {
  jd.__onMethod__(eventName, function (e) {
    "function" == typeof callback && callback(e);
  });
};

//金融风控刷脸能力jspai
jd.faceRecognition = function (params) {
  jd.__invokeMethod__("faceRecognition", params); //nativeAPIname为原生方法的名称
};

// cps定制跳转，增加固定参数
jd.cpsJumpToNative = function () {
  var jumpParams =
    arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var param = {};
  if (jumpParams) {
    jumpParams.m_param = {
      jda: "123.158382952868842949672.1577764369.1577764373.1583829529.3",
    };
    jumpParams.from = "JDMiniApp";
    jumpParams.union_open = "union_cps";
    var paramsStr = encodeURIComponent(JSON.stringify(jumpParams));
    var urlStr = "openapp.jdmobile://virtual?params=" + paramsStr;
    param.dataParam = JSON.stringify({ url: urlStr });
  }
  jd.__invokeMethod__("navigateToNative", param);
};
// 茅台专用 图像识别
jd.imgRecognition = function (e) {
  jd.__invokeMethod__("imgRecognition", e);
};
// 门店小程序专用 生成会员码弹窗
jd.showMembersCode = function (e) {
  jd.__invokeMethod__("showMembersCode", e);
};
// 获取加密 uuid
jd.requestUUIDSync = function (e) {
  var t = {};
  jd.__invokeMethod__(
    "requestUUIDSync",
    {},
    {
      beforeSuccess: function (e) {
        t = e;
      },
    }
  );
  return t;
};
// 摘星0元单
jd.submitZeroOrder = function (e) {
  jd.__invokeMethod__("submitZeroOrder", e);
};

// 获取风控sdk的token，增加与11.3.0版本，用于京东支付小程序
jd.getJDJRRiskToken = function (e) {
  jd.__invokeMethod__("getJDJRRiskToken", e);
};

// 给RN发消息
jd.postMessageToRN = function (params) {
  jd.__invokeMethod__("postMessageToRN", params); 
};

// 业务通用请求api
jd.mpCommonRequest = function (params) {
  if (!params){
    console.error("mpCommonRequest 缺少必要的参数");
    return;
  }
  if (!params.method) {
    console.error("缺少 method 字段");
    return;
  }
  if (!params.functionId) {
    console.error("缺少 functionId 字段");
    return;
  }
  if (!params.data) {
    console.error("缺少 data 字段");
    return;
  };
  jd.__invokeMethod__("mpCommonRequest", params);
};


// 业务通用请求api
jd.mpJdCommonRequest = function (params) {
  if (!params) {
    console.error("mpJdCommonRequest 缺少必要的参数");
    return;
  }
  if (!params.method) {
    console.error("缺少 method 字段");
    return;
  }
  if (!params.functionId) {
    console.error("缺少 functionId 字段");
    return;
  }
  if (!params.data) {
    console.error("缺少 data 字段");
    return;
  };
  jd.__invokeMethod__("mpJdCommonRequest", params);
};

// 京东支付
jd.onPaySettingBack = function (callback) {
  jd.__onMethod__("onPaySettingBack", function (e) {
    "function" == typeof callback && callback(e);
  });
};

jd.jumpToPaySetting = function (params) {
  jd.__invokeMethod__("jumpToPaySetting", params);
};

ext&&ext.setCanIUse({
  requestUUIDSync: {
     "1.0.0": [],
  },
  faceRecognition: {
     "1.0.0": [],
  },
  getJda: {
     "1.13.23": [],
  }
})

// 门详关闭卡片半弹层
jd.closeCard = function (params) {
  jd.__invokeMethod__("closeCard", params);
};

// 门详关闭商详半弹层
jd.mpCloseProductDetail = function (params) {
  jd.__invokeMethod__("mpCloseProductDetail", params);
};

// app是否同意隐私协议
jd.isAppPrivacyAgreedSync = function (e) {
  var t = {};
  jd.__invokeMethod__(
    "isAppPrivacyAgreedSync",
    {},
    {
      beforeSuccess: function (e) {
        t = e;
      },
    }
  );
  return t;
};

// 获取当前app模式
jd.getAppModeSync = function (e) {
  var t = {};
  jd.__invokeMethod__(
    "getAppModeSync",
    {},
    {
      beforeSuccess: function (e) {
        t = e;
      },
    }
  );
  return t;
};

// 获取当前小程序状态
jd.getMPStatusSync = function (e) {
  var t = {};
  jd.__invokeMethod__(
    "getMPStatusSync",
    {},
    {
      beforeSuccess: function (e) {
        t = e;
      },
    }
  );
  return t;
};

// 获取埋点的字段jda，2024.09.10增加，jdapp-13.2.8
jd.getJda = function (params) {
  jd.__invokeMethod__("getJda", params);
};